package raytracer;

class Main {
    public static final int DEPTH = 2;
    public static final int WIDTH = 512;
    public static final int HEIGHT = 512;

    public static void main(String[] args) {
        if (args.length > 4) {
            System.err.println("Arguments: [scene file] [recursion depth] [width] [height]");
            return;
        }

        ControlFrame renderFrame = new ControlFrame();
        if (args.length > 0) {
            int recursionDepth = DEPTH;
            int width = WIDTH;
            int height = HEIGHT;
            if (args.length >= 2)
                recursionDepth = Integer.parseInt(args[1]);
            if (args.length >= 3)
                width = Integer.parseInt(args[2]);
            if (args.length >= 4)
                height = Integer.parseInt(args[3]);

            renderFrame.setParams(args[0], width, height, recursionDepth);
        }
        renderFrame.pack();
        renderFrame.show();
    }
}
