package raytracer.internal;

/**
 *
 * A representation of a point in three dimensions
 *
 */
public class Point extends Tuple3f {

    /**
     * Creates a point at the location (x,y,z)
     */
    public Point(float x, float y, float z) {
        super(x, y, z);
    }

    /**
     * Copy constructor
     * @param p Point to duplicate
     */
    public Point(Tuple3f p) {
        super(p);
    }

    /**
     * Adds a vector to a point
     * @param v Vector to add
     * @return New point object
     */
    public Point add(Vector v) {
        return new Point(this.x + v.x, this.y + v.y, this.z + v.z);
    }

    /**
     * Subtracts a point from a point
     * @param p Point to subtract from this
     * @return The difference vector from this point to origin
     */
    public Vector sub(Point p) {
        return new Vector(this.x - p.x, this.y - p.y, this.z - p.z);
    }

}
