package raytracer.internal;

/**
 *
 * Represents geometric transformations with matrices
 *
 */
public class Transformation {
    private Matrix matrix;

    /**
     * Creates a "do-nothing" transformation
     */
    public Transformation() {
        matrix = new Matrix();
        matrix.unify();
    }

    public void setMatrix(Matrix matrix) {
        this.matrix = matrix;
    }

    /**
     * Returns the transformation matrix
     * @return Tranformation matrix
     */
    public Matrix getMatrix() {
        return matrix;
    }

    /**
     * Returns the inverse of the transformation matrix
     * @return Inverse of tranformation matrix
     */
    public Matrix getInverse() {
        return matrix.inverse();
    }
}
