package raytracer.internal;

/**
 * Created by IntelliJ IDEA.
 * User: Bogdy
 * Date: 18.05.2003
 * Time: 12:12:35
 * To change this template use Options | File Templates.
 */
public class Tuple3f {
    public float x;
    public float y;
    public float z;

    public Tuple3f(Tuple3f t) {
        this.x = t.x;
        this.y = t.y;
        this.z = t.z;
    }

    public Tuple3f(float x, float y, float z) {
        this.x = x;
        this.y = y;
        this.z = z;
    }

    public Tuple3f transform(Transformation t) {
        float m[][] = t.getMatrix().matrix;
        final float fx = x * m[0][0] + y * m[1][0] + z * m[2][0] + m[3][0];
        final float fy = x * m[0][1] + y * m[1][1] + z * m[2][1] + m[3][1];
        final float fz = x * m[0][2] + y * m[1][2] + z * m[2][2] + m[3][2];
        return new Tuple3f(fx, fy, fz);
    }

    public void print() {
        System.out.println("Tuple:"+x+" "+y+" "+z);
    }

    public boolean same(Tuple3f t) {
        return Utils.sameFloat(t.x, x) &&
                Utils.sameFloat(t.y, y) &&
                Utils.sameFloat(t.z, z);
    }
}
