package raytracer.objects;

import raytracer.internal.Color;
import raytracer.internal.Point;

public class Light extends NamedObject {
    private Color color = new Color(1, 1, 1);
    private Point position = new Point(0, 0, 0);

    public void setColor(float r, float g, float b) {
        color = new Color(r, g, b);
    }

    public void setPosition(float x, float y, float z) {
        position = new Point(x, y, z);
    }

    public Color getColor() {
        return color;
    }

    public Point getPosition() {
        return position;
    }

    public NamedObject setAttributes(NamedObject newObject) {
        final Light light = (Light)newObject;
        light.setColor(color.r, color.g, color.b);
        light.setPosition(position.x, position.y, position.z);
        return newObject;
    }

    /**
     * @return a copy of the current object
     */
    public NamedObject duplicate() {
        return setAttributes(new Light());
    }
}
