package raytracer.tests;

import junit.framework.Test;
import junit.framework.TestSuite;
import raytracer.tests.internal.ColorTest;
import raytracer.tests.internal.MatrixTest;
import raytracer.tests.internal.UtilsTest;
import raytracer.tests.internal.VectorTest;
import raytracer.tests.objects.QuadricTest;
import raytracer.tests.objects.SphereTest;
import raytracer.tests.objects.UnionTest;


public class TestMain {
    public static Test suite() {
        TestSuite suite = new TestSuite();

		// internal
        suite.addTestSuite(MatrixTest.class);
		suite.addTestSuite(VectorTest.class);
		suite.addTestSuite(ColorTest.class);
		suite.addTestSuite(UtilsTest.class);
		
		// objects
		suite.addTestSuite(QuadricTest.class);
		suite.addTestSuite(SphereTest.class);
        suite.addTestSuite(UnionTest.class);
        return suite;
    }

    public static void main(String args[]) {
        junit.textui.TestRunner.run(suite());
    }
}
