package raytracer.tests.internal;

/**
 * Created by IntelliJ IDEA.
 * User: Bogdy
 * Date: 02.05.2003
 * Time: 13:49:10
 * To change this template use Options | File Templates.
 */

import junit.framework.TestCase;
import raytracer.internal.Utils;
import raytracer.internal.Vector;

public class VectorTest extends TestCase {
    private Vector a, b, c, axb, i, normal, r;
    private float dotab, lenA, len2A;

    public VectorTest(String s) {
        super(s);
    }

    protected void setUp() {
        a = new Vector(3, 9, 5);
        b = new Vector(6, 1, 7);
        c = a.normalize();
        axb = new Vector(58, 9, -51);
        dotab = 62;
        lenA = 10.7238f;
        len2A = 115;

        i = new Vector(-1, 1, 0).normalize();
        normal = new Vector(0, 1, 0);
        r = new Vector(-1, -1, 0).normalize();
    }

    public void testConstructor() {
        assertNotNull("vector not initialized", a);
        assertNotNull("vector not initialized", b);
        assertNotNull("vector not initialized", c);
        assertNotNull("vector not initialized", axb);
    }

    public void testMul() {
        assertTrue("a cross b", a.crossProduct(b).same(axb));
        assertTrue("a dot b", Utils.sameFloat(a.dotProduct(b), dotab));
    }

    public void testLen() {
        assertTrue("len a", Utils.sameFloat(a.length(), lenA));
        assertTrue("len squared of a", Utils.sameFloat(a.length2(), len2A));

        assertTrue("len norm a", Utils.sameFloat(c.length(), 1));
        assertTrue("len squared of norm a", Utils.sameFloat(c.length2(), 1));
    }

    public void testReflexion() {
        assertTrue("reflect i", i.reflect(normal).same(r));
    }

/*    protected void runTest() {

}
*/
    protected void tearDown() {
    }
}
