package raytracer.tests.objects;

/**
 * Created by IntelliJ IDEA.
 * User: Bogdy
 * Date: 02.05.2003
 * Time: 13:49:10
 * To change this template use Options | File Templates.
 */

import junit.framework.TestCase;
import raytracer.internal.*;
import raytracer.objects.Quadric;

public class QuadricTest extends TestCase {
	private Quadric quadric = null;
	private Ray ray = null;

	public QuadricTest(String s) {
		super(s);
	}

	protected void setUp() {
		quadric = new Quadric();
		quadric.setParameter(1, 1, 1, 0, 0, 0, 0, 0, 0, -1f);
		ray = new Ray(new Point(0,0,-1.5f), new Vector(0,0,1));
	}

	public void testConstructor() {
		assertNotNull("quadric not initialized", quadric);
		assertNotNull("ray not initialized", ray);
	}

	public void testRayIntersectNormal() {
		assertNotNull("quadric not initialized", quadric);
		assertNotNull("ray not initialized", ray);
		Hit hit = quadric.intersectRay(ray);
		assertEquals("intersection result failed "+hit.getT(), 0.5f, hit.getT(), Constants.OUTSIDE_EPSILON);
		Vector normal = hit.getNormal().normalize();
		assertTrue("calc normal failed", normal.same(new Vector(0,0,-1)));
	}

	public void testInside() {
		assertNotNull("quadric not initialized", quadric);
		boolean inside1 = quadric.isInside(new Point(0,0,.5f));
		boolean inside2 = quadric.isInside(new Point(0,0,1.5f));
		assertTrue("inside failed", inside1);
		assertFalse("inside failed", inside2);
	}

    public void testDuplicate() {
        Quadric quadric = new Quadric();
        quadric.setParameter(3, 4, 2, 5, 1, 7, 2, 6, 2, 1);
        //quadric.getMatrix().print();
        assertNotNull("quadric not initialized", quadric);
        Quadric quadric2 = (Quadric)quadric.duplicate();
        //quadric2.getMatrix().print();
        assertNotNull("quadric not initialized", quadric2);
        assertTrue("duplicate quadric not the same", quadric.same(quadric2));
    }
/*    protected void runTest() {

	}
	*/
	protected void tearDown() {
	}
}
