package raytracer.tests.objects;

/**
 * Created by IntelliJ IDEA.
 * User: Bogdy
 * Date: 02.05.2003
 * Time: 13:49:10
 * To change this template use Options | File Templates.
 */

import junit.framework.TestCase;
import raytracer.internal.*;
import raytracer.objects.Sphere;
import raytracer.objects.Union;
import raytracer.objects.Material;

public class UnionTest extends TestCase {
    private Sphere sphere1 = null;
    private Sphere sphere2 = null;
    private Union union = null;
    private final float sin60 = (float)Math.sin(Math.PI/3f);

    public UnionTest(String s) {
        super(s);
    }

    protected void setUp() {
        sphere1 = new Sphere();
        sphere1.setCenter( .5f, 0, 0);
        sphere1.setRadius(1);
        sphere2 = new Sphere();
        sphere2.setCenter(-.5f, 0, 0);
        sphere2.setRadius(1);
        union = new Union();
        union.setFirst(sphere1);
        union.setSecond(sphere2);
    }

    public void testConstructor() {
        assertNotNull("union not initialized", union);
        assertNotNull("sphere1 not initialized", sphere1);
        assertNotNull("sphere1 not initialized", sphere2);
    }

    public void testRayIntersect() {
        // hit one sphere
        Ray ray = new Ray(new Point(.5f,0,-7), new Vector(0,0,1));
        assertNotNull("ray not initialized", ray);
        Hit t = union.intersectRay(ray);
        assertEquals("intersection result failed "+t, 6, t.getT(), Constants.OUTSIDE_EPSILON);

        // both spheres
        Ray ray2 = new Ray(new Point(0,0,-7), new Vector(0,0,1));
        assertNotNull("ray2 not initialized", ray2);
        Hit t2 = union.intersectRay(ray2);
        final Vector normal = union.calcNormal(t2);
        assertEquals("intersection result failed "+t2, 7-sin60, t2.getT(), Constants.OUTSIDE_EPSILON);
        assertTrue("calc normal", normal.same(sphere1.calcNormal(t2)) || normal.same(sphere2.calcNormal(t2)));
    }

    public void testInside() {
        // inside sphere 1
        assertTrue("isInside failed", union.isInside(new Point(1.3f,0,0)));
        // inside sphere 2
        assertTrue("isInside failed", union.isInside(new Point(-1.3f,0,0)));
        // inside both spheres
        assertTrue("isInside failed", union.isInside(new Point(0,0,0)));
        // outside
        assertFalse("isInside failed", union.isInside(new Point(0,0,3)));
    }

/*    protected void runTest() {

    }
    */
    protected void tearDown() {
    }
}
